package WebFlow.edys;

import WebFlow.event.*;
import WebFlow.*;
import java.io.*;

import java.util.*;
import org.omg.CORBA.*;

public class runCasc2dImp extends WebFlow.BeanContextChildSupport
    implements runCasc2dOperations {

String msg_;
org.omg.CORBA.Object peer;
PropertyChangeSupport pcs;
String lmsStatusFile;
String TouchCommand;

  boolean flag;
  boolean moreEvents;
  boolean waitForUpdate;
  boolean firstTime;
  boolean waitForStart = true;
  boolean notLast = true;
  boolean waitForNext;
  long lastMod, newMod;
  String[] toEdysFiles;
  selectEdysInput edysInputFile;
  String display; 
  String Project; 
  int bytes_read;
  String testFile;
  casc2dThread cT;
  String casc2dDir;
  String outFile, oldFile;
  int i, itxt;
  String ContentsFile, ContentsFileURL, FileBaseURL, OutFileBase, OutContents;
 

public runCasc2dImp(org.omg.CORBA.Object peer, String msg)
   throws WebFlow.NullPointerException
  {
    super(peer);	
    msg_ = msg;    
    pcs = new PropertyChangeSupport(peer, this);
    this.peer = peer;
    casc2dDir =  "/home/B8D/haupt/CASC2D/lms";
    lmsStatusFile = "/home/B8D/haupt/CASC2D/lms/lms_stat.dat";
    testFile = lmsStatusFile;
    TouchCommand = "/bin/touch";
    ContentsFile = "/home/B8D/haupt/CASC2D/contents.txt";
    //OutFileBase = "/home/T11F/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/toEDYS/";
    OutFileBase = "/home/B7D/globus/haupt/Jigsaw/Jigsaw/WWW/toEDYS/";
    OutContents = OutFileBase + "contents.txt";
    ContentsFileURL = "http://hawaii.npac.syr.edu/fromEDYS/contents.txt";
    FileBaseURL = "http://hawaii.npac.syr.edu/fromEDYS/";
    //ContentsFileURL = "http://134.164.35.154/fromEDYS/contents.txt";
    //FileBaseURL = "http://134.164.35.154/fromEDYS/";
  }

    public void runAgain(EdysDone EDevent) {
     String project = EDevent.getProject();

     receiveData();

           System.out.println("now reactivate casc2d");
	    moreEvents=nextEvent();

            /* determine the last modification time of  *.edy files */

           File edysInput = new File(testFile);       
           if(edysInput.exists()) {
              System.out.println("Edys input exists");
              lastMod=edysInput.lastModified();
              System.out.println("LastModified "+lastMod);
           }
           else {
              Date currDate = new Date();
              lastMod=currDate.getTime();
              System.out.println("current time "+lastMod); 
          }
           if(moreEvents) {
              reactivateCasc2d();
	   }
           else {
             System.out.println("All events processed");
      	   }

        waitForData();    
    }

    
   public void run() {
    firstTime=true;
    flag=true;
    moreEvents=true;
    //    edysInputFile = new selectEdysInput();

    cT = new casc2dThread();
    cT.start();
    waitForData();
   }


     private void reactivateCasc2d(){
       try {
        Process p=Runtime.getRuntime().exec(TouchCommand+" "+lmsStatusFile);
        p.waitFor();
       } 
       catch (Exception e) {
         System.out.println("touch error: "+e.toString());
       } 
    }

    private void waitForData(){
    
      if(moreEvents) {



       /* as soon as CASC2D produced data, send them back to EDYS */
       
       waitForUpdate=true;
       while(waitForUpdate) {  
           slowDown(1000);
       File F1 = new File(testFile);
       if(F1.exists()) {
         newMod = F1.lastModified();
         //System.out.println(lastMod+" "+newMod); 
       }
       else {
         System.out.println("file "+testFile+" does not exist!");
         cT.stop();
       }

          if(newMod > lastMod) {
             /* testFile has been updated! */
             System.out.println("was: "+lastMod+" and now is "+newMod);
             lastMod = newMod;         
             waitForUpdate=false;
	  }
       }
      }
       SendData();   
    }


  private void SendData() {

         /* send the data */

         /* send lms_stat.dat */

   if(waitForStart) {
      while(waitForStart) {
      outFile = readFile(casc2dDir+"/lms_stat.dat");
      System.out.println("lms_stat.dat");
      System.out.println(outFile);
      int idxs=outFile.indexOf("1111");
      if(idxs>-1) {
         waitForStart=false;
         oldFile=outFile.substring(0,10);
         }
      }
    } 
    else {
      waitForNext=true;
      while(waitForNext) {
         outFile = readFile(casc2dDir+"/lms_stat.dat");
         if(outFile.substring(0,10).equals(oldFile)) {
            System.out.println("... not yet");
	 }
	 else 
           { waitForNext=false;
           oldFile=outFile.substring(0,10);
	   }
      }

      notLast = nextEvent();
      System.out.println("==================================");
      System.out.println(outFile);
      System.out.println("==================================");
      System.out.println(notLast);
      System.out.println("==================================");

    }
          
   sendEDY("lms_stat.dat","lms_stat");
   System.out.println("send lms_stat: "+outFile);

         /* send all files with extension .edy */
         
	  /* read the directory */
   File dataDir = new File(casc2dDir);
   if(dataDir.exists()) {
      toEdysFiles = dataDir.list(edysInputFile);
      try {
        BufferedWriter out = new BufferedWriter(new FileWriter(OutContents));

        for(i=0;i<toEdysFiles.length;i++) {
          System.out.println(i+" "+toEdysFiles[i]);
          long fileSize=(new File(casc2dDir+"/"+toEdysFiles[i]).length());
          System.out.println(toEdysFiles[i]+" "+fileSize);

          /* create contents file and copy files to OutFileBase */
               out.write(toEdysFiles[i]+".txt");
               out.newLine();
               sendEDY(toEdysFiles[i],toEdysFiles[i]);
	}
        if(!notLast) out.write("end");
        out.newLine();
        out.flush();
        out.close();  
      } catch (IOException e){System.err.println("IOError "+e.toString());}
      firstTime = false;

	  /* cannot use nextEvent() directly; casc2d may quit before
             above data are sent rewritting lms_stat.dat    */

/*
      if(nextEvent()) {         
??      outport.send("end");
      }
      else {
??      outport.send("done");
      }
*/
   }
   else {
          System.out.println("Oops! directory "+casc2dDir+" does not exist");
   }
     System.out.println("now create event");
     Casc2dDoneImp ev = new Casc2dDoneImp(peer,"http://whatever.com");
     System.out.println("fireEvent!");
     pcs.fireEvent("Casc2dDone",ev);
         
  } 

      /*
      doto {
---> the following happens when the casc2d thread is dead

       System.out.println("CASC2D sending sygnal <done>");


        if(outport.isConnected()) {
             outport.send("done");
	}
        else {
        System.out.println("Oops: rCASC2D_obsidian cannot sent <done> sygnal");
        }
       
      }
      */

  synchronized void slowDown(long sleepTime) {
        try{
             wait(sleepTime);
        }
         catch (Exception e) {System.out.println(e);}
   }

  boolean nextEvent() {

    String stst = readFile(lmsStatusFile);
    System.out.println("nextEvent?");  
    System.out.println(stst);
    int idx=stst.indexOf("9999");
    System.out.println("idx="+idx);
    if(idx>-1) {
       /* no more events */
       return false;
    }
    else {
       return true;
    }
  }
  /** Reading file with name "fileName" **/
  String readFile(String fileName)
   {
     System.out.println("I am reading the file:"+fileName);
 
     File file = new File(fileName);
     char[] data = null;

     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       System.out.println("file size is "+size);
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
         chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.out.println("There is IOException during reading file:"+e);
     } 
      return new String(data);
   }

      //???????????    
/** write data from "fileContent" into file with name "fileName" */
 public void  writeFile(String fileName,String fileContent)
   {
     /*
     System.out.println("I am writing the file:"+fileName+
                        " content:"+fileContent);
 
     try{
       FileOutputStream fw = new FileOutputStream(fileName);
       DataOutputStream dos = new DataOutputStream(fw);
       //write fileContent to file at once
       dos.writeBytes(fileContent);
     }catch(IOException e){
       System.out.println("There is IOException during writing file:"+e);
     }
    */
   }

  public void getHTTPfile(String fileName, String sourceURL) {
    
    /*    InputStream in = null;
    OutputStream out = null;
    bytes_read = 0;
    int oneread = 0;
 
    try {    
      System.out.println("ReceiveFile: "+sourceURL);
      URL url = new URL(sourceURL);
      URLConnection urlcon = url.openConnection();
      int remoteFileLength = urlcon.getContentLength();    
      System.out.println("ReceiveFile: file lenghth: "+remoteFileLength);   
      in = urlcon.getInputStream(); 
      out = new FileOutputStream(fileName);
      byte[] buffer = new byte[4096];
       while(bytes_read < remoteFileLength) {
              oneread = in.read(buffer);
              out.write(buffer,0,oneread);
              setBytesRead(oneread);  
        } 
      }
      catch (Exception e) {System.out.println("ReceiveFile "+e);}       

      finally {
         try{in.close(); out.close();} catch (Exception e){;}
      }
      */
  }

  public int setBytesRead(int bytes_read_) {
      bytes_read += bytes_read_;
      return bytes_read;
  }
      //--------------------???? 

    void receiveData() {       
      String inFileName;

      getHTTPfile(ContentsFile,ContentsFileURL);
      try {
      BufferedReader reader = new BufferedReader(new InputStreamReader
                             (new FileInputStream(ContentsFile)));
         String line;
         Vector fileList = new Vector();
         while ((line = reader.readLine()) != null) fileList.addElement(line);
    
         for(int i=0; i<fileList.size(); i++) {
           inFileName=(String)fileList.elementAt(i);
	   /* strip .txt extension */
           itxt = inFileName.lastIndexOf(".txt");
           inFileName=inFileName.substring(0,itxt);
           getHTTPfile(casc2dDir+"/"+inFileName,FileBaseURL+inFileName);
	 }
                            
      } catch (Exception e){System.out.println(e.toString());}
    }

    public void sendEDY(String fromName, String toName) {

	/* in spite of the name this routine does not send anything
           instead it copies a file to the Web server directory
           changing its name from EdysName to CascName */

    FileInputStream source=null;
    FileOutputStream dest=null;
      try {
        String inputFile = casc2dDir+"/"+fromName;
        String outputFile = OutFileBase+toName+".txt";
        source = new FileInputStream(new File(inputFile));
        dest = new FileOutputStream(new File(outputFile));
        byte[] buffer=new byte[1024];
        while(true) {
          bytes_read = source.read(buffer);
          if(bytes_read==-1) break;
          dest.write(buffer,0,bytes_read);
        }
      } catch (Exception e) {System.err.println(e);}
        finally {
	    try {source.close();} catch (Exception e){;}
	    try {dest.close();} catch (Exception e){;}
        }   
        
    }

}

   class casc2dThread extends Thread {

     String display = "sandman.npac.syr.edu:0";
     //String display = "aga.npac.syr.edu:0";
     //String display = "maine.npac.syr.edu:0";
     //     String display = "134.164.35.154:0";
     //     String display = "Sonny.wes.hpc.mil:0";
     String lmsDir = "/home/B8D/haupt/CASC2D/lms";
     String script = "/tmp/casc2d.pl";
     String command = script;

   public casc2dThread() {
   System.out.println("casc2d thread started...");
  }  


     public void run() {


      try { 

      FileWriter writer = new FileWriter(script);
      writer.write("#!/usr/local/bin/perl\n"); 
      writer.write("chdir \""+lmsDir+"\";\n");
      writer.write("$executable = \"xterm -d "+display+ " -e CASC2Dlms_solaris lms.prj\";\n");
      writer.write("`$executable`;");
      writer.flush();
      writer.close();      
      }
      catch (Exception e) {System.out.println("Oh shit! "+e.toString());}

        try {
              Process p=Runtime.getRuntime().exec("chmod 755 "+script);
              p.waitFor();
        }
        catch (Exception e) {System.out.println("CASC2D Error: "+e.toString());
	}
        try {
              Process p=Runtime.getRuntime().exec(script);
              p.waitFor();
        }
        catch (Exception e) {System.out.println("CASC2D Error: "+e.toString());
	}

    }  
}

class selectEdysInput implements FilenameFilter {

int idx;

  public boolean accept(File dir, String name) {
    idx = name.indexOf(".edy");
    if(idx > -1) return true;
    else return false;   
  }

}

